package com.example;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.scene.control.*;
import javafx.scene.control.Alert.AlertType;
import javafx.scene.input.MouseEvent;

public class CheckOutController {

    @FXML
    private Label mainTitle;

    @FXML
    private Button cartBtn;

    @FXML
    private Button loginBtn;

    @FXML
    private Label checkoutHeader;

    @FXML
    private Label paymentTitle;

    @FXML
    private Label paymentSubtitle;

    @FXML
    private Button creditCard;

    @FXML
    private Button bill;

    @FXML
    private Button paypal;

    @FXML
    private TextField fullNameField;

    @FXML
    private TextField addressField;

    @FXML
    private TextField cityField;

    @FXML
    private TextField zipField;

    @FXML
    private ComboBox<String> countryComboBox;

    @FXML
    private TextField cardNumberField;

    @FXML
    private TextField cardHolderNameField;

    @FXML
    private TextField expiryDateField;

    @FXML
    private PasswordField cvvField;

    @FXML
    private Button submitButton;

    public void initialize() {
        // Initialize the country combo box with some values
        countryComboBox.getItems().addAll("United States", "Canada", "United Kingdom", "Germany", "Australia");
        countryComboBox.getSelectionModel().selectFirst();
    }

    @FXML
    void handleTitleClick(MouseEvent event) throws IOException {
        App.setRoot("shop");
    }

    @FXML
    private void handleCartButton(ActionEvent event) throws IOException {
        App.setRoot("cart");
    }

    @FXML
    private void handleLoginButton(ActionEvent event) throws IOException {
        App.setRoot("login");
    }

    @FXML
    private void handlePaymentMethod(ActionEvent event) {
        Button clickedButton = (Button) event.getSource();
        System.out.println("Selected payment method: " + clickedButton.getId());
    }

    @FXML
    private void handleSubmit(ActionEvent event) throws IOException {
        System.out.println("Submit button clicked.");

        String fullName = fullNameField.getText();
        String address = addressField.getText();
        String city = cityField.getText();
        String zip = zipField.getText();
        String country = countryComboBox.getValue();
        String cardNumber = cardNumberField.getText();
        String cardHolderName = cardHolderNameField.getText();
        String expiryDate = expiryDateField.getText();
        String cvv = cvvField.getText();

        // Validate the input fields
        if (fullName.isEmpty() || address.isEmpty() || city.isEmpty() || zip.isEmpty() || cardNumber.isEmpty()
                || cardHolderName.isEmpty() || expiryDate.isEmpty() || cvv.isEmpty() || country.isEmpty()) {
            Alert alert = new Alert(AlertType.ERROR, "Please fill out all fields.", ButtonType.OK);
            alert.showAndWait();
        } else {
            Alert alert = new Alert(AlertType.INFORMATION, "Form submitted successfully.", ButtonType.OK);
            alert.showAndWait();
            FileWriter fileWriter = new FileWriter("cart.txt", false);
            App.setRoot("shop");
        }
    }
}
