package com.example;

import java.io.IOException;

import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.scene.control.Alert;
import javafx.scene.control.Button;
import javafx.scene.control.ButtonType;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.control.Alert.AlertType;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.HBox;
import javafx.scene.layout.Pane;
import javafx.scene.layout.VBox;

public class RegisterController {

    @FXML
    private Button cartBtn;

    @FXML
    private TextField cityCodeInput;

    @FXML
    private Label cityCodeLabel;

    @FXML
    private TextField cityInput;

    @FXML
    private Label cityLabel;

    @FXML
    private VBox contactUs;

    @FXML
    private Button createAccountButton;

    @FXML
    private TextField emailInput;

    @FXML
    private Label emailLabel;

    @FXML
    private VBox followUs;

    @FXML
    private VBox footer;

    @FXML
    private Label footerAbout;

    @FXML
    private Label footerBluesky;

    @FXML
    private Label footerContact;

    @FXML
    private VBox footerCopy;

    @FXML
    private Label footerCopyText;

    @FXML
    private Label footerEmail;

    @FXML
    private Label footerFacebook;

    @FXML
    private Label footerHeading2;

    @FXML
    private Label footerHeading3;

    @FXML
    private Label footerHome;

    @FXML
    private Label footerInstagram;

    @FXML
    private HBox footerLinks;

    @FXML
    private Label footerPhone;

    @FXML
    private Label footerText;

    @FXML
    private VBox formFields;

    @FXML
    private Label formTitle;

    @FXML
    private HBox header;

    @FXML
    private Button loginBtn;

    @FXML
    private GridPane mainGrid;

    @FXML
    private Label mainTitle;

    @FXML
    private TextField nameInput;

    @FXML
    private Label nameLabel;

    @FXML
    private TextField passwordInput;

    @FXML
    private Label passwordLabel;

    @FXML
    private TextField phoneInput;

    @FXML
    private Label phoneLabel;

    @FXML
    private VBox quickLinks;

    @FXML
    private Pane spacerPane;

    @FXML
    private TextField streetInput;

    @FXML
    private Label streetLabel;

    @FXML
    private TextField surnameInput;

    @FXML
    private Label surnameLabel;

    @FXML
    void handleTitleClick(MouseEvent event) throws IOException {
        App.setRoot("shop");
    }

    @FXML
    private void handleCartButton(ActionEvent event) throws IOException {
        App.setRoot("cart");
    }

    @FXML
    private void handleLoginButton(ActionEvent event) throws IOException {
        App.setRoot("login");
    }

    @FXML
    private void handleCreateAccountButtonClick(ActionEvent event) throws IOException {
        String name = nameInput.getText();
        String surname = surnameInput.getText();
        String email = emailInput.getText();
        String password = passwordInput.getText();
        String phone = phoneInput.getText();
        String street = streetInput.getText();
        String city = cityInput.getText();
        String cityCode = cityCodeInput.getText();

        if (validateForm(name, surname, email, password, phone, street, city, cityCode)) {
            App.account = new Account(name, surname, email, password, phone, street, city, cityCode);
            Alert alert = new Alert(AlertType.INFORMATION, "Account created.", ButtonType.OK);
            alert.showAndWait();
            App.setRoot("login");
        } else {
            Alert alert = new Alert(AlertType.ERROR, "You have to fill all fields!", ButtonType.OK);
            alert.showAndWait();
        }
    }

    private boolean validateForm(String name, String surname, String email, String password, String phone,
            String street, String city,
            String cityCode) {
        // Basic validation to ensure no fields are empty
        return !(name.isEmpty() || surname.isEmpty() || email.isEmpty() || password.isEmpty() || phone.isEmpty()
                || street.isEmpty()
                || city.isEmpty() || cityCode.isEmpty());
    }
}
