package com.example;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;

import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextArea;
import javafx.scene.input.MouseEvent;

public class ShopController {

    private static final String CART_FILE = "cart.txt";

    @FXML
    private Button cartBtn;

    @FXML
    private Button loginBtn;

    @FXML
    private Button cardBtn1, cardBtn2, cardBtn3, cardBtn4;
    @FXML
    private Button cardBtn5, cardBtn6, cardBtn7, cardBtn8;

    @FXML
    private Label mainTitle;

    @FXML
    private TextArea cardText1, cardText2, cardText3, cardText4;
    @FXML
    private TextArea cardText5, cardText6, cardText7, cardText8;

    @FXML
    public void initialize() {
        System.out.println("ShopController initialized.");
    }

    @FXML
    void handleTitleClick(MouseEvent event) throws IOException {
        App.setRoot("shop");
    }

    @FXML
    private void handleCartButton(ActionEvent event) throws IOException {
        App.setRoot("cart");
    }

    @FXML
    private void handleLoginButton(ActionEvent event) throws IOException {
        App.setRoot("login");
    }

    // Book Addition Handlers
    @FXML
    private void handleAddToCartButton1(ActionEvent event) {
        addToCart("Lord of the Rings",
                "A high-fantasy epic by J.R.R. Tolkien. The story follows the journey of Frodo Baggins and his companions as they attempt to destroy the One Ring and defeat the Dark Lord Sauron.");
    }

    @FXML
    private void handleAddToCartButton2(ActionEvent event) {
        addToCart("The Wheel of Time",
                "A sprawling epic fantasy series by Robert Jordan. It follows the journey of Rand al'Thor as he struggles to control his newfound powers and faces the ultimate battle between light and shadow.");
    }

    @FXML
    private void handleAddToCartButton3(ActionEvent event) {
        addToCart("The Chronicles of Narnia",
                "A beloved fantasy series by C.S. Lewis. It tells the magical adventures of children in the land of Narnia, filled with mythical creatures, epic battles, and profound allegorical themes.");
    }

    @FXML
    private void handleAddToCartButton4(ActionEvent event) {
        addToCart("The Earthsea Cycle",
                "A fantasy series by Ursula K. Le Guin. It explores the coming-of-age journey of Ged, a young wizard, as he navigates the balance of power, magic, and morality.");
    }

    @FXML
    private void handleAddToCartButton5(ActionEvent event) {
        addToCart("The First Law Trilogy",
                "A grimdark fantasy series by Joe Abercrombie. It features morally complex characters, brutal realism, and intertwining stories of politics, war, and betrayal.");
    }

    @FXML
    private void handleAddToCartButton6(ActionEvent event) {
        addToCart("The Kingkiller Chronicle",
                "An epic fantasy series by Patrick Rothfuss. It recounts the life of Kvothe, a gifted musician and magician, as he seeks revenge and unravels mysteries in a richly imagined world.");
    }

    @FXML
    private void handleAddToCartButton7(ActionEvent event) {
        addToCart("The Mistborn Series",
                "A unique fantasy series by Brandon Sanderson. It combines a rich magic system based on metals with a story of rebellion, heroism, and unexpected twists.");
    }

    @FXML
    private void handleAddToCartButton8(ActionEvent event) {
        addToCart("The Stormlight Archive",
                "A grand fantasy epic by Brandon Sanderson. It weaves together multiple characters' stories in a richly detailed world of war, magic, and ancient secrets.");
    }

    private void addToCart(String bookTitle, String bookDescription) {
        try (BufferedWriter writer = new BufferedWriter(new FileWriter(CART_FILE, true))) {
            writer.write(bookTitle + " - " + bookDescription);
            writer.newLine();
            System.out.println("Added to cart: " + bookTitle + " with description: " + bookDescription);
        } catch (IOException e) {
            System.err.println("Failed to add item to cart: " + e.getMessage());
        }
    }
}
